searchNodes=[{"doc":"Generates a starter Scenic application. This is the easiest way to set up an empty new Scenic project. If you would like a more full-featured example, please use: mix scenic.new.example Install scenic.new mix archive.install hex scenic_new Build the Starter Application First, navigate the command-line to the directory where you want to create your new Scenic application. Then run the following commands: (change my_app to the name of your application) mix scenic.new my_app cd my_app mix do deps.get, scenic.run Running and Debugging Once the application and its dependencies are set up, there are two main ways to run it. If you want to run your application under IEx so that you can debug it, simply run iex -S mix This works just like any other Elixir application. If you want to run your application outside of IEx , you should start it like this: mix scenic.run The Starter Application The starter application created by the generator above shows the basics of building a Scenic application. It has four scenes, two components, and a simulated sensor. Scene Description Splash The Splash scene is configured to run when the application is started in the config/config.exs file. It runs a simple animation, then transitions to the Sensor scene. It also shows how intercept basic user input to exit the scene early. Sensor The Sensor scene depicts a simulated temperature sensor. The sensor is always running and updates it's data through the Scenic.SensorPubSub server. Primitives The Primitives scenes displays an overview of the basic primitive types and some of the styles that can be applied to them. Components The Components scene shows the basic components that come with Scenic. The crash button will cause a match error that will crash the scene, showing how the supervision tree restarts the scene. It also shows how to receive events from components. Component Description Nav The navigation bar at the top of the main scenes shows how to navigate between scenes and how to construct a simple component and pass a parameter to it. Note that it references a clock, creating a nested component. The clock is positioned by dynamically querying the width of the ViewPort Notes The notes section at the bottom of each scene is very simple and also shows passing in custom data from the parent. The simulated temperature sensor doesn't collect any actual data, but does show how you would set up a real sensor and publish data from it into the Scenic.SensorPubSub service. What to read next Next, you should read guides describing the overall Scenic structure. This is in the documentation for Scenic itself","ref":"Mix.Tasks.Scenic.New.html","title":"Mix.Tasks.Scenic.New","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Scenic.New.html#run/1","title":"Mix.Tasks.Scenic.New.run/1","type":"function"},{"doc":"Generates a starter Scenic application. This is the easiest way to set up a new Scenic project. Install scenic.new mix archive.install hex scenic_new Build the Starter Application First, navigate the command-line to the directory where you want to create your new Scenic application. Then run the following commands: (change my_app to the name of your application) mix scenic.new my_app cd my_app mix do deps.get, scenic.run Running and Debugging Once the application and its dependencies are set up, there are two main ways to run it. If you want to run your application under IEx so that you can debug it, simply run iex -S mix This works just like any other Elixir application. If you want to run your application outside of IEx , you should start it like this: mix scenic.run The Starter Application The starter application created by the generator above shows the basics of building a Scenic application. It has four scenes, two components, and a simulated sensor. Scene Description Splash The Splash scene is configured to run when the application is started in the config/config.exs file. It runs a simple animation, then transitions to the Sensor scene. It also shows how intercept basic user input to exit the scene early. Sensor The Sensor scene depicts a simulated temperature sensor. The sensor is always running and updates it's data through the Scenic.SensorPubSub server. Sensor spec The Sensor scene implemendted using specs Primitives The Primitives scenes displays an overview of the basic primitive types and some of the styles that can be applied to them. Components The Components scene shows the basic components that come with Scenic. The crash button will cause a match error that will crash the scene, showing how the supervision tree restarts the scene. It also shows how to receive events from components. Component Description Nav The navigation bar at the top of the main scenes shows how to navigate between scenes and how to construct a simple component and pass a parameter to it. Note that it references a clock, creating a nested component. The clock is positioned by dynamically querying the width of the ViewPort Notes The notes section at the bottom of each scene is very simple and also shows passing in custom data from the parent. The simulated temperature sensor doesn't collect any actual data, but does show how you would set up a real sensor and publish data from it into the Scenic.SensorPubSub service. What to read next Next, you should read guides describing the overall Scenic structure. This is in the documentation for Scenic itself","ref":"Mix.Tasks.Scenic.New.Example.html","title":"Mix.Tasks.Scenic.New.Example","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Scenic.New.Example.html#run/1","title":"Mix.Tasks.Scenic.New.Example.run/1","type":"function"},{"doc":"Does much of the work to set up Scenic in an existing project, such as Nerves. The typical use of this task is to install Scenic into a Nerves project. This assumes that you have already installed Nerves. You should read use the Nerves Installation Guide. Create a new project Then create a new Nerves project and set up Scenic within it mix nerves.new hello_nerves cd hello_nerves mix scenic.setup This also works to set up Scenic in a blank Elixir project mix new hello_world cd hello_world mix scenic.setup At this point, the main file structures are set up, but not completely hooked together. Set up the Scenic dependency Add the following lines the this list of deps in the project's mix.exs file. Notice that they are usable for all the Nerves targets. (Actually, the local driver doesn't work for bbb yet and is very slow and needs work on rpi4, but the point is that it works across host and the device target...) { :scenic , &quot;~&gt; 0.11.0-beta.0&quot; } , { :scenic_driver_local , &quot;~&gt; 0.11.0-beta.0&quot; } , Make sure your application is configured to start This should be in your mix.exs file. If using Nerves, it will start MyApplication.Application def application do [ mod : { MyApplication , [ ] } , extra_applications : [ :logger , :scenic ] ] end Add Scenic to your app's supervisor Next, you need to add Scenic to your app's supervisor so that it starts scenic. Something like this should be in your MyApp or MyApp.Application module. def start ( _type , _args ) do # start the application with the configured viewport viewport_config = Application . get_env ( :&lt; % = @app % &gt; , :viewport ) children = [ { Scenic , [ viewport_config ] } , &lt; % = @mod % &gt; . PubSub.Supervisor ] |&gt; Supervisor . start_link ( strategy : :one_for_one ) end Configure your assets Add the following to your config.exs file. Change the app name as appropriate. This configuration is usually the same for all targets. config :scenic , :assets , module : MyApplication.Assets Configure your ViewPort Next, you need to configure your ViewPort. This instructs Scenic how to draw to the screen, or window. This is typically different for the various Nerves targets. The following example would go in the host.exs file. Or, if this is just a regular elixir project running on a Mac/PC/Linux machine, it could go in config.exs config :my_application , :viewport , size : { 800 , 600 } , theme : :dark , default_scene : MyApplication.Scene.Home , drivers : [ [ module : Scenic.Driver.Local , window : [ title : &quot;My Application&quot; ] , on_close : :stop_system ] ] This configuration could be for a Nerves device. In this case an rpi3, that I've been using, but it could be any device with a fixed screen. config :my_application , :viewport , size : { 800 , 600 } , theme : :dark , default_scene : MyApplication.Scene.Home , drivers : [ [ module : Scenic.Driver.Local , position : [ scaled : true , centered : true , orientation : :normal ] , ] ] Scenic.Driver.Local has quite a few options you can set. Please see it's documentation for more. Get the Dependencies and Run You should now be ready to fetch the dependencies and run your project. Run these commands from within your project's main directory. mix deps.get iex -S mix The Starter Application The starter application created by the generator adds a minimal set of Scenic files displays information about the system it is running on. What to read next Next, you should read guides describing the overall Scenic structure. This is in the documentation for Scenic itself","ref":"Mix.Tasks.Scenic.Setup.html","title":"Mix.Tasks.Scenic.Setup","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Scenic.Setup.html#run/1","title":"Mix.Tasks.Scenic.Setup.run/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html","title":"ScenicNew.Common","type":"module"},{"doc":"","ref":"ScenicNew.Common.html#assets_readme/1","title":"ScenicNew.Common.assets_readme/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#attribution/1","title":"ScenicNew.Common.attribution/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#check_application_name!/2","title":"ScenicNew.Common.check_application_name!/2","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#check_directory_existence!/1","title":"ScenicNew.Common.check_directory_existence!/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#check_mod_name_availability!/1","title":"ScenicNew.Common.check_mod_name_availability!/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#check_mod_name_validity!/1","title":"ScenicNew.Common.check_mod_name_validity!/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#comp_readme/1","title":"ScenicNew.Common.comp_readme/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#cyanoramphus/0","title":"ScenicNew.Common.cyanoramphus/0","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#elixir_version_check!/0","title":"ScenicNew.Common.elixir_version_check!/0","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#fairy_grove/0","title":"ScenicNew.Common.fairy_grove/0","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#formatter/1","title":"ScenicNew.Common.formatter/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#gitignore/1","title":"ScenicNew.Common.gitignore/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#pubsub_readme/1","title":"ScenicNew.Common.pubsub_readme/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#scene_readme/1","title":"ScenicNew.Common.scene_readme/1","type":"function"},{"doc":"","ref":"ScenicNew.Common.html#scenic_version/0","title":"ScenicNew.Common.scenic_version/0","type":"function"}]